/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.listjoiner;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class ListJoiner {

    public static String joinItemsAsNaturalLanguage(List<String> list, boolean useOxfordComma) {
        if (list.isEmpty()) {
            return "";
        } else if (list.size() == 1) {
            return list.get(0);
        } else if (list.size() == 2) {
            return String.join(" and ", list);
        } else {
            String joinedWithoutLast = String.join(", ", list.subList(0, list.size() - 1));
            String separator = useOxfordComma && list.size() > 2 ? "," : "";  // Add comma only if using Oxford comma and list has more than 2 elements
            return joinedWithoutLast + separator + " and " + list.get(list.size() - 1);
        }
    }

    public static void main(String[] args) {

        List<String> colors = new ArrayList<>();
        colors.add("red");
        colors.add("blue");
        colors.add("orange");
        colors.add("green");

        System.out.println("Using Conditional Logic without Oxford comma: " + joinItemsAsNaturalLanguage(colors, false));
        System.out.println("Using Conditional Logic with Oxford comma: " + joinItemsAsNaturalLanguage(colors, true));
    }
}
